PROGRAM YUDX;

    USES
       CRT, DOS, DRDXCC;

    CONST
       max=1023;
       busy=128;
       dot=32;
       dash=16;
       foot=8;

    TYPE
       dupes=RECORD
          wkd: string[6];
          cwq, phq: array [1..6] OF Boolean;
          END;

    VAR
       x, scr: real;
       CWout, inp, morse: STRING;
       snr, b1, qqq, tole, leto, base, qnr, mult, i, j, k: INTEGER;
       tmr,y,m,h,s,d: WORD;
       w,bd,ptt,key,ena,c: BYTE;
       tmp, log: TEXT;
       nyu, pin, novi, novy, old, ok, cw, dupe: BOOLEAN;
       lc, cc, mycall: STRING[12];
       rprt, sc: String[6];
       bdfq, temp: string[5];
       rst, time, mode: STRING[4];
       itu, myitu, mycnt: STRING[2];
       qsoti: array [0..max] OF dupes;
       itumult: ARRAY [1..6,0..75] OF BOOLEAN;
       yumults: ARRAY [1..6,0..50] OF BOOLEAN;
       CWbuffer: ARRAY [1..6] OF String;
       ch, tch, zz: CHAR;

    Procedure Paddle;

       CONST
          t: INTEGER=0;

       Begin
          b1:=Port[BASE-1];
          IF (b1 AND dot)=0 THEN BEGIN
             Port[BASE]:=key;
             Sound(1000);
             Delay(tmr);
             Port[BASE]:=ptt;
             Nosound;
             Delay(tmr);
             t:=0;
             END;
          b1:=Port[BASE-1];
          IF (b1 AND dash)=0 THEN BEGIN
             Port[BASE]:=key;
             Sound(1000);
             Delay(3*tmr);
             Port[BASE]:=ptt;
             Nosound;
             Delay(tmr);
             t:=0;
             END;
          b1:=Port[BASE-1];
          IF t=maxint THEN BEGIN
             Port[BASE]:=ena;
             t:=0;
             END
          ELSE Inc(t);
          END;

       Procedure Obseg;

          Begin
             Case bd OF
                1: bdfq:='1800 ';
                2: bdfq:='3500 ';
                3: bdfq:='7000 ';
                4: bdfq:='14000';
                5: bdfq:='21000';
                6: bdfq:='28000';
                END;
             END;

    Procedure Setmode;

      Begin
          IF cw THEN BEGIN
             mode:=' CW ';
             rst:='599 ';
             END
          ELSE BEGIN
             mode:=' PH ';
             rst:=' 59 ';
             END;
         end;

    PROCEDURE QSY;

       BEGIN
          REPEAT
             Write(#13,'Freq 1=1.8; 2=3.5; 3=7.0; 4=14; 5=21; 6=28 MHz : ');
             zz:=Readkey;
             UNTIL zz IN ['1'..'6'];
          Write(zz);
          bd:=Ord(zz)-48;
          Obseg;
          END;

    PROCEDURE Getstr;

       BEGIN
         inp:='';
         ch:=' ';
         tch:=' ';
         REPEAT
           IF pin THEN Paddle;
           IF keypressed THEN BEGIN
             ch:=UpCase(ReadKey);
             IF (ch IN ls) OR (ch IN ds) OR (ch='/') THEN BEGIN
                Write(ch);
                inp:=inp+ch;
                END
             ELSE IF (ch=#8) AND (inp<>'') THEN BEGIN
                Delete(inp,Length(inp),1);
                Write(#8,' ',#8);
                END
             ELSE IF ch=#0 THEN BEGIN
                tch:=Readkey;
                IF tch=#65 THEN QSY
                ELSE IF tch=#66 THEN BEGIN
                   cw:=NOT cw;
                   Setmode;
                   END
                ELSE IF tch=#67 THEN Dec(tmr,tmr DIV 8)
                ELSE IF tch=#68 THEN Inc(tmr,tmr DIV 8);
                END;
             ok:=((ch=#13) AND (inp='')) OR (tch=#60) OR (tch=#61);
             END;
             UNTIL (ch=#0) OR (ch=#13) OR (ch=#27);
          END;

    Procedure Dupecheck;

           BEGIN
             sc:=call+'  ';
             i:=0;
             qqq:=qnr;
             REPEAT
                old:=sc=qsoti[i].wkd;
                Inc(i);
                UNTIL old OR (i>qnr);
             IF old THEN BEGIN
                qqq:=i-1;
                IF cw THEN dupe:=qsoti[qqq].cwq[bd]
                ELSE dupe:=qsoti[qqq].phq[bd];
                END
             ELSE dupe:=false;
             END;

    Procedure Homework;

       BEGIN
             novy:=nyu AND (cty='YU  ');
             IF novy THEN BEGIN
                case pfx[2] of
                   'N': leto:=0;
                   'O': leto:=10;
                   'T': leto:=20;
                   'U': leto:=30;
                   'Z': leto:=40;
                   end;
                IF pfx[3]='0' THEN i:=10
                ELSE i:=Ord(pfx[3])-48;
                Inc(leto,i);
                novy:=NOT yumults[bd,leto];
                END;
             Val(zon,tole,j);
             novi:=(j=0) AND NOT itumult[bd,tole];
             IF dupe THEN x:=0
             ELSE IF zon=myitu THEN x:=1
             ELSE IF cont=mycnt THEN x:=3
             ELSE x:=5;
          END;

    Procedure Insert;

            BEGIN
                 WITH qsoti[qqq] DO BEGIN
                   IF NOT old THEN BEGIN
                      wkd:=sc;
                      Inc(qnr);
                      END;
                   IF cw THEN cwq[bd]:=true
                   ELSE phq[bd]:=TRUE;
                   END;
                scr:=scr+x;
                IF novi THEN Inc(mult);
                IF novy THEN Inc(mult);
                Inc(snr);
                END;

    Procedure Display;

       BEGIN
                Window(1,1,75,w);
                IF novi THEN BEGIN
                   itumult[bd,tole]:=TRUE;
                   GotoXY(tole,bd);
                   Write('*');
                   END;
                IF novy THEN BEGIN
                   yumults[bd,leto]:=TRUE;
                   GotoXY(leto,8+bd);
                   Write('*');
                   END;
             END;


    PROCEDURE Reload;

       BEGIN
          REPEAT
             Readln(log,inp);
             IF (Pos('QSO:',inp)=1) THEN BEGIN
              temp:=Copy(inp,6,5);
              bd:=0;
              REPEAT
                 Inc(bd);
                 Obseg;
                 UNTIL (bdfq=temp) OR (bd=6);
              cw:=inp[12]='C';
              Call:=Copy(inp,51,12);
              itu:=Copy(inp,68,2);
              Call:=Copy(call,1,Pos(' ',call)-1);
              Prefix;
              DXsts;
              Dupecheck;
              Homework;
              Insert;
              Display;
              END;
             UNTIL EOF(log);
          Close(log);
          END;

    PROCEDURE Cabrillo;

       BEGIN
             Rewrite(log);
             Writeln(log,'START-OF-LOG: 2.0');
             Writeln(log,'CONTEST: YU-DX');
             Writeln(log,'CLAIMED-SCORE: 123456');
             Writeln(log,'CALLSIGN: ',mycall);
             REPEAT
               Write(#13, 'Category : SINGLE, MULTI : ');
               Getstr;
               UNTIL (inp='SINGLE') OR (inp='MULTI');
             WRITE(log,'CATEGORY: ',inp,'-OP ');
             Writeln;
             IF inp[1]='M' THEN BEGIN
                Writeln(log,'ALL MIXED');
                Write('Operators: ');
                Readln(inp);
                Writeln(log,'OPERATORS: ',inp);
                END
             ELSE BEGIN
                REPEAT
                   WRITE(#13,'Band : ALL, 10M, 15M, 20M, 40M, 80M, 160M : ');
                   Getstr;
                   UNTIL (inp='160M') OR (inp='ALL') OR (inp[3]='M');
                   Write(log,inp,' ');
                   Writeln;
                REPEAT
                   Write(#13,'Mode : CW, SSB, MIXED : ');
                   Getstr;
                   UNTIL (inp='CW') OR (inp='SSB') OR (inp='MIXED');
                Writeln(log,inp);
                Writeln;
                END;
             Write('Club : ');
             Readln(inp);
             Writeln(log,'CLUB: ',inp);
             WRITE('Name : ');
             READLN(inp);
             WRITELN(log,'NAME: ',inp);
             Write('Street & nr.: ');
             Readln(inp);
             Writeln(log,'ADDRESS: ',inp);
             Write('ZIP & Town  : ');
             Readln(inp);
             Writeln(log,'ADDRESS: ',inp);
             Write('Country : ');
             Readln(inp);
             Writeln(log,'ADDRESS: ',inp);
             Writeln(log,'CREATED-BY: S56A.1983-2001');
             Writeln(log,'SOAPBOX: It takes the mathematician to make such a "standard format"!');
             Close(log);
             END;

    Procedure CWinit;

       BEGIN
          CWbuffer[1]:='call report';
          CWbuffer[2]:='TU mycall';
          CWbuffer[3]:='TU report';
          CWbuffer[4]:='mycall';
          CWbuffer[5]:='CQ YU mycall mycall TEST';
          CWbuffer[6]:='call mycall';
          Assign(tmp,'CWmsg.txt');
{$I-}     Reset(tmp);  {$I+}
          i:=0;
          IF IOResult=0 THEN BEGIN
            REPEAT
              Readln(tmp,inp);
              IF Length(inp)>3 THEN BEGIN
                Inc(i);
                CWbuffer[i]:=inp;
                END;
              UNTIL (i=6) OR EOF(tmp);
              Close(tmp);
              END;
           END;

    Procedure CWmsg;

       VAR
          r,s,t: string;

       BEGIN
          i:=Ord(tch)-58;
          s:=CWbuffer[i];
          k:=Length(s);
          t:='';
          r:='';
          FOR j:=1 TO k DO BEGIN
             IF s[j]>' ' THEN t:=t+s[j];
             IF (j=k) OR (s[j]=' ') THEN BEGIN
                IF t='call' THEN r:=r+Call
                ELSE IF t='report' THEN r:=r+rprt
                ELSE IF t='mycall' THEN r:=r+mycall
                ELSE r:=r+t;
                r:=r+' ';
                t:='';
                END;
             END;
          CWout:=r;
          END;

    PROCEDURE CWO;

       VAR
          mbfr: ARRAY [1..6] OF INTEGER;

       BEGIN
          Port[base]:=ptt;
          Cwmsg;
          k:=0;
          REPEAT
             Inc(k);
             zz:=CWout[k];
             i:=1;
             IF zz='?' THEN i:=75
             ELSE
                WHILE (zz<>morse[i]) AND (i<63) DO Inc(i);
             IF i<>63 THEN BEGIN
                NoSound;
                Delay(2*tmr);
                j:=6;
                IF zz=' ' THEN Delay(tmr)
                ELSE
                   REPEAT
                      IF Odd(i) THEN BEGIN
                         mbfr[j]:=1;
                         Dec(i);
                         END
                      ELSE BEGIN
                         mbfr[j]:=3;
                         Dec(i,2);
                         END;
                      Dec(j);
                      i:=i DIV 2;
                      UNTIL i=0;
                WHILE j<6 DO BEGIN
                   Inc(j);
                   Sound(800);
                   Port[base]:=key;
                   Delay(mbfr[j]*tmr);
                   NoSound;
                   Port[base]:=ptt;
                   Delay(tmr);
                   END;
                END;
             IF KeyPressed THEN BEGIN
                ch:=Readkey;
                IF ch=#0 THEN BEGIN
                   ch:=Readkey;
                   IF ch=#68 THEN Inc(tmr,tmr DIV 8)
                   ELSE IF ch=#67 THEN Dec(tmr,tmr DIV 8);
                   END;
                END;
             UNTIL (k=Length(CWout)) OR (ch=#27);
          Port[base]:=ena;
          tch:=' ';
          END;


    Procedure Grid;

        BEGIN
          FOR bd:=1 TO 6 DO BEGIN
             FOR i:=1 TO y DO BEGIN
                IF i MOD 10 = 0 THEN Write('|')
                ELSE Write('.');
                END;
             Obseg;
             IF bdfq[5]=' ' THEN temp:=Copy(bdfq,1,4)
             ELSE temp:=bdfq;
             Val(temp,i,k);
             IF k=0 THEN BEGIN
                x:=i;
                x:=x/1000;
                IF x<10 THEN Writeln(x:4:1)
                ELSE Writeln(x:4:0);
                END;
             END;
          END;

    PROCEDURE Okno;

       BEGIN
          y:=75;
          ClrScr;
          Textcolor(yellow);
          Grid;
          FOR i:=1 TO y DO Write(i DIV 10);
          Writeln(' ITU');
          FOR i:=1 TO y DO Write(i MOD 10);
          Writeln(' ZON');
          IF nyu THEN BEGIN
             y:=50;
             Grid;
             Write(' 4N1-4N0 |');
             Write(' 4O1-4O0 |');
             Write(' YT1-YT0 |');
             Write(' YU1-YU0 |');
             Writeln(' YZ1-YZ0 |');
             END;
         w:=WhereY+1;
         END;


    PROCEDURE Init;

       BEGIN
          pin:=FALSE;
          snr:=0;
          scr:=0;
          mult:=0;
          qnr:=0;
          FOR j:=1 TO 6 DO BEGIN
             FOR i:=0 TO 75 DO itumult[j,i]:=FALSE;
             FOR i:=0 TO 50 DO yumults[j,i]:=false;
             END;
          FOR i:=0 TO max DO
             WITH qsoti[i] DO BEGIN
                wkd:='      ';
                FOR j:=1 TO 6 DO BEGIN
                   cwq[j]:=false;
                   phq[j]:=false;
                   END;
                END;
          Write('Callsign : ');
          Getstr;
          Writeln;
          mycall:=inp;
          cc:=mycall+'         ';
          call:=inp;
          Prefix;
          DXsts;
          myitu:=zon;
          rprt:='5NN '+myitu;
          i:=Pos('0',rprt);
          IF i<>0 THEN rprt[i]:='T';
          mycnt:=cont;
          nyu:=cty<>'YU  ';
          REPEAT
             Write(#13,'PC CW PORT : 0=None;  1=COM1; 2=COM2; 3=LPT1; 4=LPT2 : ');
             ch:=Readkey;
             UNTIL ch IN ['0'..'4'];
          Writeln(ch);
          base:=Ord(ch)-48;
          pin:=base>2;
          Case base OF
             0:;
             1: base:=$03F8+4;
             2: base:=$02F8+4;
             3: base:=$0378+2;
             4: base:=$0278+2;
             END;
          IF pin THEN BEGIN
             b1:=Port[base-1];
             pin:=((b1 AND busy)<>0) AND ((b1 AND dash)<>0) AND ((b1 AND dot)<>0);
             ptt:=13;
             key:=5;
             ena:=0;
             END
          ELSE BEGIN
             ptt:=10;
             key:=11;
             ena:=8;
             END;
          IF base>0 THEN Port[base]:=ena;
          morse:=
            'ETIANMSURWDKGOHVF*L*PJBXCYZQ**54*3***2 ******16*/*****7***8*90*';
          END;

     Procedure Vreme;

           BEGIN
             Gettime(h,m,s,d);
             time:=Chr(48+h div 10)+Chr(48+h mod 10)+Chr(48+m div 10)+Chr(48+m mod 10);
             Write(#13,bdfq,mode,' ',time,' ');
             ClrEol;
             END;

    BEGIN
       Window(1,1,80,25);
       Textbackground(blue);
       Textcolor(white);
       ClrScr;
       Writeln('F7-QSY, F8-CW/SSB, F9-QRQ, F10-QRS *** GL YUDX & 73 de Mario, S56A, N1YU ***');
       DXCCLoad;
       Init;
       Assign(log,mycall+'.YU');
{$I-}  Reset(log);              {$I+}
       IF IOResult=0 THEN BEGIN
          Okno;
          Reload;
          END
       ELSE BEGIN
         IF nyu THEN BEGIN
           Write('ITU zone ',myitu,' OK? : ');
           Getstr;
           IF Length(inp)=2 THEN myitu:=inp;
           END
         ELSE BEGIN
           Write('Drzava YU? : ');
           Getstr;
           nyu:=Length(inp)>1;
           END;
         Cabrillo;
         Okno;
         END;
       Window(1,w,80,25);
       GotoXY(1,1);
       Write('Mode CW/PH : ');
       Getstr;
       Writeln;
       cw:=inp[1]='C';
       Write('CW timing  : ');
       Readln(tmr);
       CWinit;
       Setmode;
       QSY;
       Window(1,w-1,80,25);
       Textcolor(white);
       Clrscr;
       Writeln('Freq Mode Time Callsign    Report Val New  ?  QSO Point Mults DXCC   Score');
       Window(1,w,80,25);
       REPEAT
          REPEAT
             Vreme;
             Getstr;
             IF Length(inp)>2 THEN call:=inp
             ELSE IF cw AND (base>0) AND (tch IN [#59..#64]) THEN CWO;
             UNTIL Length(inp)>2;
          IF (call[2] IN ds) OR (call[3] IN ds) THEN BEGIN
             Prefix;
             DXsts;
             Dupecheck;
             REPEAT
                Vreme;
                lc:=call+'         ';
                Write(lc,rst,zon);
                Homework;
                Write(x:3:0);
                IF novi OR novy THEN Write('  *   ')
                ELSE IF dupe THEN Write(' DUPE ')
                ELSE Write('      ');
                Write('OK ');
                IF cw AND (base>0) AND (tch IN [#59..#64]) THEN CWO;
                Getstr;
                IF length(inp)=2 THEN zon:=inp;
                UNTIL ok OR (ch=#27);
             IF ok THEN BEGIN
                GetDate(y,m,s,d);
                Append(log);
                Write(log,'QSO: ',bdfq,mode,y,'-',m DIV 10,m mod 10,'-',d DIV 10,d mod 10,' ');
                Writeln(log,time,' ',cc,rst,' ',myitu,' ',lc, rst,' ', zon);
                Close(log);
                Insert;
                Writeln(snr:4,scr:6:0,mult:6,' ',cty,scr*mult:8:0);
                c:=WhereY;
                Display;
                Window(1,w,80,25);
                GotoXY(1,c);
                END;
             IF cw AND (base>0) AND (tch IN [#59..#64]) THEN CWO;
             END;
          UNTIL (inp='QRT') OR (qnr>max);
       Append(log);
       Writeln(log,'END-OF-LOG:');
       scr:=scr*mult;
       Writeln(log,'CLAIMED-SCORE: ',scr:6:0);
       Close(log);
       Assign(tmp,mycall+'.cbr');
       Rewrite(tmp);
       Reset(log);
       Readln(log,inp);
       Writeln(tmp,inp);
       Readln(log,inp);
       Writeln(tmp,inp);
       Readln(log,inp);
       Writeln(tmp,'CLAIMED-SCORE: ',scr:6:0);
       While NOT eof(log) AND (Pos('QSO:',inp)=0) DO BEGIN
          Readln(log,inp);
          Writeln(tmp,inp);
          END;
       While NOT eof(log) DO BEGIN
          Readln(log,inp);
          IF Pos('QSO:',inp)=1 THEN Writeln(tmp,inp);
          END;
       Writeln(tmp,'END-OF-LOG:');
       Close(tmp);
       END.
